class Blob
  def initialize(dbname)
    @dbname = dbname
    @idx = Hash.new{|hash,key| hash[key] = {} }
    @free_idx = Hash.new{|hash,key| hash[key] = [] }
    @free_end = 0
    begin
      f = File.open(@dbname+".idx", "rb")
      while line = f.gets
        key, name, idx, size, exp = line.chomp.split(/:/)
        name = name.intern
        idx = idx.to_i
        size = size.to_i
        exp = exp.to_i
        @idx[key][name] = [idx, size, exp]
      # area_end = idx + (1<<exp)
      # if @free_end < area_end
      #    @free_end = area_end
      # end
      end
    rescue Errno::ENOENT
      f = File.open(@dbname+".idx", "wb")
      retry
    ensure
    p  :close
      f.close
    end
    begin
      f = File.open(@dbname+".spc", "rb")
      unless f.eof?
        @free_end = f.gets.chomp.to_i
      end
      while line = f.gets
        exp, idxary = line.chomp.split(/=/,2)
        exp = exp.to_i
        @free_idx[exp].replace idxary.split(/:/).map{|i|i.to_i}
      end
    rescue Errno::ENOENT
      f = File.open(@dbname+".spc", "wb")
      retry
    ensure
    p  :close
      f.close
    end
    begin
      f = File.open(@dbname+".exp", "rb")
    rescue Errno::ENOENT
      f = File.open(@dbname+".exp", "wb")
      retry
    ensure
    p  :close
      f.close
    end
    @rom = Hash.new{|hash,key| hash[key] = {} }
    @ram = Hash.new{|hash,key| hash[key] = {} }
  end
  def [](key, name)
    @rom[key][name] or
    begin
      idx, size, exp = @idx[key][name]
      File.open(@dbname+".exp", "rb") do |f|
        @rom[key][name] = f.seek(idx).read(size)
      end
    end
  end
  def []=(key, name, value)
    @ram[key][name] = value
    @rom[key][name] = value
    update_index(key, name, value)
  end
  def update_index(key, name, value)
    idx, size, exp = @idx[key][name]
p  [:p0, idx, size, exp]
    if value.nil?
      size = nil
      flo = nil
      free(idx, exp)
      idx = nil
      @idx[key].delete(name)
    else
      size = value.size
      flo = (size-1).log2floor+1
      if flo != exp
        free(idx, exp)
        idx = allocate(flo)
        @idx[key][name] = [idx, size, flo]
      end
    end
p  [:p1, idx, size, flo]
    return idx, size, flo
  end
  def self.open(dbname)
    this = self.new(dbname)
    if block_given?
      begin
        yield this
      ensure
        this.close
      end
    end
  end
  def close
    File.open(@dbname+".exp", "rb+") do |f|
      @ram.each do |key, hash|
        hash.each do |name, value|
          next if @idx[key][name].nil?
          idx, size, exp = @idx[key][name]
p  [:p2, idx, size, exp]
#         next if idx.nil?
          f.seek(idx)
          size = 1<<exp
          f.print(value[0,size].ljust(size))
        end
      end
    end
    File.open(@dbname+".idx", "wb") do |f|
      @idx.each do |key, hash|
        hash.each do |name, ary|
          f.puts [key, name, *ary].join(":")
        end
      end
    end
    File.open(@dbname+".spc", "wb") do |f|
      f.puts @free_end
      @free_idx.each do |exp, idxary|
        f.puts [exp, idxary.join(":")].join("=")
      end
    end
  end
  def free(idx, exp)
    return unless idx
    return unless exp
    @free_idx[exp].push idx
  end
  def allocate(exp)
    idx = @free_idx[exp].pop
    unless idx
      idx = @free_end
      @free_end = idx + (1<<exp)
    end
    idx
  end
end
class Fixnum
  @@size=1.size
  @@byte=8
  @@m=@@byte*@@size
  def log2floor
    m=@@m
    m-(1..m).find{|i| self[m-i]==1}
  end
end

if $0 == __FILE__
# Blob.open('test') do |blob|
blob = Blob.new('test')
#for key in 'aa'..'zz'
#  blob[key, :name] = key
#end
    blob['a', :name] = 'moriq'
    blob['b', :name] = 'Kazuhiro Yoshida'
    blob['abcd', :name] = 'moriq'
    blob['a', :name] = nil
    blob['c', :addr] = 'takamatsu'
  # blob['c', :nick] = 'right'
  # blob['a', :name] = nil
  # blob['b', :name] = nil
  # blob['c', :nick] = nil
#for key in 'cc'..'xx'
#p [key, blob[key, :name]]
#  blob[key, :name] = nil
#end
blob.close
# end
end
