require 'thread'

class List

class Item
  @field_name = []
  def self.field_name
    @field_name
  end
  def self.field_name=(list)
    @field_name = list
  end

  @field_size = []
  def self.field_size
    @field_size
  end
  @size = 1+16
  def self.size
    @size
  end
  def self.field_size=(list)
    @field_size = list
    @size = @field_size.inject(1+16){|i,x| i+=x+1 }+1
  end
  self.field_size = [16]

  attr_reader :key
  def Item.new_key
    require 'digest/md5'
    md5 = Digest::MD5::new
    md5.update(String(Time::now))
    md5.update(String(rand(0)))
    md5.update(String($$))
    md5.update('foobar')
    md5.hexdigest[0,16]
  end
  def initialize(key, *fields)
    @key = key || raise
    @fields = fields
  end
  def self.new_from_line(str)
    key, *fields = str.split(/\t/)
    self.new(key, *fields)
  end
  TAB_STOP = " "*8
  def to_line
    [@key, *@fields].map{|i| String(i).tr("\t",TAB_STOP) }.join("\t")
  end
  def field_by_name(name)
    @fields[self.class.field_name.index(name)]
  end
  def to_hash
    hash = { :key => @key }
    @fields.each_with_index do |field, idx|
      hash[self.class.field_name[idx]] = field
    end
    hash
  end
  def edit(*fields)
    [@fields.size, fields.size].max.times do |idx|
     @fields[idx] = fields[idx] if fields[idx]
    end
  end
end

  @dbname = 'list.db'
  def self.dbname
    @dbname
  end
  def self.dbname=(dbname)
    @dbname = dbname
  end

  @item_class = Item
  def self.item_class
    @item_class
  end
  def self.item_class=(item_class)
    @item_class = item_class
  end

  def initialize
    @item = {}
    @mutex = Mutex.new
    load
  end

  def add(*fields)
    while @item.key?(key = self.class.item_class.new_key) do end
    item = self.class.item_class.new(key, *fields)
    @item[key] = item
    save item
    item
  end

  def edit(key, *fields)
    item = find(key)
    item.edit(*fields)
    save item
    item
  end

  def remove(key)
    item = find(key)
    if item
      @item[key] = nil
      delete item
    end
    item
  end

  def find(key)
    @item[key] || fetch(key)
  end
  private :find

  def fetch_hash_all
    fetch_all
    if block_given?
      @item.each do |key, item|
        yield item.to_hash
      end
    else
      @item.collect{|key, item| item.to_hash }
    end
  end

  def fetch_hash(key)
    item = find(key)
    return nil unless item
    item.to_hash
  end

private
begin
	require 'gdbm'
	DB = GDBM
rescue LoadError
	begin
		require 'dbm'
		DB = DBM
	rescue LoadError
		require 'sdbm'
		DB = SDBM
	end
end
  def load
    @mutex.synchronize do
      @db = DB.new(self.class.dbname)
    # @db.each do |key, line|
    #   item = self.class.item_class.new_from_line(line)
    #   @item[key] = item
    # end
    end
  end
  def fetch(key)
    line = nil
    @mutex.synchronize do
      line = @db[key]
    end
    item = self.class.item_class.new_from_line(line)
    @item[key] = item
    item
  end
  def fetch_all
    @mutex.synchronize do
      @db.each do |key, line|
        next if @item[key]
        item = self.class.item_class.new_from_line(line)
        @item[key] = item
      end
    end
  end
  def save(item)
    @mutex.synchronize do
      @db[item.key] = item.to_line
    end
  end
  def delete(item)
    @mutex.synchronize do
      @db[item.key] = nil
    end
  end
end

if $0 == __FILE__
  List::Item.field_name = [:name, :long_field_name]
  List::Item.field_size = [6, 3]
p List::Item.size
  list = List.new
# item = List::Item.new
  item = list.add('moriq')
  item = list.add( 'm' * List::Item.field_size[0] )
  item = list.add('Kazuhiro Yoshida')
# item
  list.remove(item.key)
end
