require 'thread'

class List

class Item
  @field_name = []
  def self.field_name
    @field_name
  end
  def self.field_name=(list)
    @field_name = list
  end

  attr_reader :key
  def Item.new_key
    require 'digest/md5'
    md5 = Digest::MD5::new
    md5.update(String(Time::now))
    md5.update(String(rand(0)))
    md5.update(String($$))
    md5.update('foobar')
    md5.hexdigest[0,16]
  end
  def initialize(key, *fields)
    @key = key || raise
    @fields = fields
  end
  def self.new_from_line(line)
    key, *fields = line.split(/\t/)
    self.new(key, *fields)
  end
  def self.new_from_key_line(key, line)
    *fields = line.split(/\t/)
    self.new(key, *fields)
  end
  TAB_STOP = " "*8
  def to_line_0(ary)
    ary.map{|i| String(i).tr("\t",TAB_STOP) }.join("\t")
  end
  def to_line
    to_line_0([@key] + @fields)
  end
  def to_line_except_key
    to_line_0(@fields)
  end
  def field_by_name(name)
    @fields[self.class.field_name.index(name)]
  end
  def to_hash
    hash = { :key => @key }
    @fields.each_with_index do |field, idx|
      hash[self.class.field_name[idx]] = field
    end
    hash
  end
  def edit(*fields)
    [@fields.size, fields.size].max.times do |idx|
     @fields[idx] = fields[idx] if fields[idx]
    end
  end
end

  @dbname = 'list.db'
  def self.dbname
    @dbname
  end
  def self.dbname=(dbname)
    @dbname = dbname
  end

  @item_class = Item
  def self.item_class
    @item_class
  end
  def self.item_class=(item_class)
    @item_class = item_class
  end

  def initialize
    @item = {}
    @mutex = Mutex.new
    load
  end

  def add(*fields)
    while @item.key?(key = self.class.item_class.new_key) do end
    item = self.class.item_class.new(key, *fields)
    @item[key] = item
    save item
    item
  end

  def edit(key, *fields)
    item = fetch(key)
    item.edit(*fields)
    save item
    item
  end

  def remove(key)
    item = fetch(key)
    if item
      @item[key] = nil
      delete item
    end
    item
  end

  def fetch_hash_all
    fetch_all do |key, item|
      yield item.to_hash
    end
  end

  def fetch_hash(key)
    item = fetch(key)
    return nil unless item
    item.to_hash
  end
protected
  def fetch(key)
    @item[key] ||
    @mutex.synchronize do
      line = @db[key]
      self.class.item_class.new_from_key_line(key, line)
    end
  end
  def fetch_all
    @mutex.synchronize do
      @db.each do |key, line|
        item = @item[key] || 
      self.class.item_class.new_from_key_line(key, line)
        yield key, item
      end
    end
  end
private
begin
	require 'gdbm'
	DB = GDBM
rescue LoadError
	begin
		require 'dbm'
		DB = DBM
	rescue LoadError
		require 'sdbm'
		DB = SDBM
	end
end
  def load
    @mutex.synchronize do
      @db = DB.new(self.class.dbname)
    # @db.each do |key, line|
    #   @item[key] = 
    # self.class.item_class.new_from_key_line(key, line)
    # end
    end
  end
  def save(item)
    @mutex.synchronize do
      @db[item.key] = item.to_line_except_key
    end
  end
  def delete(item)
    @mutex.synchronize do
      @db[item.key] = nil
    end
  end
end

if $0 == __FILE__
  List::Item.field_name = [:name, :long_field_name]
  list = List.new
# item = List::Item.new
  item = list.add('moriq')
  item = list.add( 'm' * 6 )
  item = list.add('Kazuhiro Yoshida')
# item
  list.remove(item.key)
end
